io.stdout:setvbuf("no")
love.window.setPosition(143, 145, 1 )
love.graphics.setDefaultFilter('nearest', 'nearest')
Camera = require 'camera'
M = require 'map'
function love.load()
    camera = Camera(0,0)
    test = {x= 2, y = 2, w = 10, h = 10}
    -- map = M(2048,2048,10,12304,test)
    map = M(512,512,10,12304,test)
end



function love.update(dt)

    local cx,cy = camera:position()
    local mx, my = love.mouse.getPosition()
    camera:lookAt(test.x,test.y)
    if love.keyboard.isDown('d') then
        test.x = test.x + 500*dt
    elseif love.keyboard.isDown('a') then
        test.x = test.x - 500*dt
    end
    if love.keyboard.isDown('w') then
        test.y = test.y - 500*dt
    elseif love.keyboard.isDown('s') then
        test.y = test.y + 500*dt
    end
    map:update(dt)

end

function love.keypressed(key)
    if key == 'escape' then
        love.event.quit()
    end
end


function love.draw()
    camera:attach()
    love.graphics.clear(110,110,255)
    drawBox(test, 255,0,0)
    map:draw()
    camera:detach()

    love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
    love.graphics.print("Current Mem: "..tostring(collectgarbage("count")), 10, 20)


end

function drawBox(box, r,g,b)
    local ar, ag, ab, aa = love.graphics.getColor( )
    love.graphics.setColor(r,g,b,70)
    love.graphics.rectangle("fill", box.x, box.y, box.w or box.width, box.h or box.height)
    love.graphics.setColor(r,g,b)
    love.graphics.rectangle("line", box.x, box.y, box.w or box.width, box.h or box.height)
    love.graphics.setColor(ar, ag, ab, aa)
end
